import "Turbine.UI";
import "Turbine.Gameplay"; -- this will expose the label control that we will implement
import "Turbine.UI.Lotro"; -- this will expose the standard window that we will implement

print=Turbine.Shell.WriteLine

exampleStorage={["12/12/2019"]={["Vidback1"]={["1"]="2:00",["2"]="Bree Rooftop Race",["3"]="",["4"]=""},["Agorlas2"]={}}}

exampleBasicEncode="<i></i><rgb=0xBasic:1:Vidback1:Vidback1:12/12/2019:2::00:Bree Rooftop Race></rgb><u></u>"

exampleDetailsEncode="<i></i><rgb=0xDetails:1:Vidback1:Insert Details Here></rgb><u></u>"

--exampleGoingEncode="<i></i><rgb=0xGoing:Vidback1:Insert Details Here></rgb><u></u>"

decode=function(code)
	local tableToReturn={}
	for i in string.gmatch(code,"<i><%/i><rgb=0x([^<^>]+)></rgb><u><%/u>") do
		--print(i)
		local event = {}
		local eventAdd={}
		local count=0
		local col=false
		local k = string.gsub(i,"%:%:","%:%<%:")
		--print(k)
		for j in string.gmatch(k,"%:([^:]+)") do
			--print(j)
			if j ~= "<" then
				if col == false then
					count=count+1
					event[tostring(count)]=j
				else
					col=false
					event[tostring(count)]=event[tostring(count)]..j
				end
				
				
				
			else
				event[tostring(count)]=event[tostring(count)]..":"
				col=true
			end
		end
		local headings={["Basic"]={"Type","Version","ID","Replace","Date","Time","Name"},["Description"]={"Type","Version","ID","Description"},["BasicRequest"]={"Type","Version","IDs"}}

		eventAdd["Type"]=event["1"]
		
		for j=2,count do
			if headings[eventAdd["Type"]][j] ~= nil then
				eventAdd[headings[eventAdd["Type"]][j]]=event[tostring(j)]
			end
		end
		tableToReturn[#tableToReturn+1]=eventAdd
		

	end
	--Turbine.PluginData.Save(Turbine.DataScope.Character, "KinCalendarTest", tableToReturn);

	return tableToReturn
end

encode=function(intb)
	local tb={}
	for i in pairs(intb) do
		tb[i]=intb[i]
	end
	str="<i></i><rgb=0x:"
	local headings={["Basic"]={"Type","Version","ID","Replace","Date","Time","Name"},["Description"]={"Type","Version","ID","Description"},["BasicRequest"]={"Type","Version","IDs"}}
	for i=1,#headings[tb["Type"]] do
		tb[headings[tb["Type"]][i]]=string.gsub(tb[headings[tb["Type"]][i]],":","::")
		tb[headings[tb["Type"]][i]]=string.gsub(tb[headings[tb["Type"]][i]],"<","")
		tb[headings[tb["Type"]][i]]=string.gsub(tb[headings[tb["Type"]][i]],">","")


		str=str..tb[headings[tb["Type"]][i]]..":"
	end
	str=str.."></rgb><u></u>"
	--print(str)
	return str
	
	
end

--encode(decode("<i></i><rgb=0x:Basic:1:Vidback1:Vidback1:12/12/2019:2::00:Bree Rooftop Race:></rgb><u></u>")[1])

